// Desktop Rox - A game by Stephen Stair (sgstair@akkit.org) for LudumDare 11 (48h game competition)
// Bitmap.h - Bitmap class to encapsulate Windows GDI bitmap drawing, and provide useful tools for interacting with bitmaps


#pragma once

#include <windows.h>

class Color
{
public:
	Color();
	Color(unsigned long c_);
	Color(int r, int g, int b);
	Color(int a, int r, int g, int b);

	void apply(Color topcolor); // alphablending pixel-combination function
	void blend(Color topcolor); // "normal" alphablending, or what is normally expected.

	unsigned long c;
};



class Bitmap
{
public:
	Bitmap(int w_=100, int h_=100);
	~Bitmap(void);

	void resize(int neww, int newh);

	HDC DC();
	unsigned long * bits();
	int wid();
	int hei();

	void cls(Color c = 0);
	void pset(int x, int y, Color c);

	void line( int x1, int y1, int x2, int y2, Color c );

	void render( int x, int y, Bitmap & bmp );

	void MakeLayeredAlpha();

protected:
	void MakeBmp(int w, int h);
	void DestroyBmp(HDC hDC_, HBITMAP hBmp_);

	HDC hDC;
	HBITMAP hBmp;
	int w,h;
	unsigned long * pBits;
};
