// Desktop Rox - A game by Stephen Stair (sgstair@akkit.org) for LudumDare 11 (48h game competition)
// Rasterizer - abstract class to represent a class responsible for rendering things.

#pragma once
#include "Bitmap.h"

class RenderPoint
{
public:
	double x, y;
};

class RenderRectangle
{
public:
	double x,y;
	double w,h;
};

class Rasterizer 
{
public:
	virtual ~Rasterizer() {}

	virtual void Bind(Bitmap * bmp, double zerox=0.0, double zeroy=0.0) = 0;

	virtual void DrawClosedFigure( int num_points, RenderPoint * rp, double rotation=0.0, double scale=1.0 ) = 0;
	virtual void DrawRectangles( int num_rectangles, RenderRectangle * rr, double rotation=0.0, double scale=1.0 ) = 0;

	virtual void FlushChanges() = 0;

};