// Desktop Rox - A game by Stephen Stair (sgstair@akkit.org) for LudumDare 11 (48h game competition)
// SpriteManager.h - Abstract class to provide interface for creating / destroying / etc sprites

#pragma once

#include <windows.h>
class BitmapSprite;
#include <vector>
using namespace std;

class BoundaryPoint
{
public:
	int x,y;
};

typedef void (*fptrClickHandler)(int, int, BitmapSprite *);

class SpriteManager
{
public:
	virtual ~SpriteManager() {}

	virtual int GetFieldWidth() = 0;
	virtual int GetFieldHeight() = 0;
	virtual vector<BoundaryPoint> GetFieldBoundary() = 0; // boundary points traverse the screen(s) CLOCKWISE
	virtual RECT GetMainWindow() = 0;
	virtual void SetClickHandler(fptrClickHandler h) {}

	virtual void AddSprite( BitmapSprite * sprite ) = 0;
	virtual bool RemoveSprite( BitmapSprite * sprite ) = 0;

	virtual void Redraw() = 0;
};